### PROBLEM LINK:

**Author:** Sumeet Verma

**Tester:** Aman Kedia

**Editorialist:** Sidhant Bansal

**Prerequisites** - Pigeon Hole Principle, Disjoint Set Union

**Difficulty :** Easy - Medium

**Expected Complexity:** O(N*N)

**Editorial -**

- Find the mid-point of each range (query) and if there are many queries having the same mid-point then only retain that query whose length is max, i.e (where r - l is maxm)
- This would have reduced the number of queries to 2*N at max, since there are 2*N number of mid-points in a string of length N.
- Now for each query do dsu union of element l with r, (l + 1) with (r - 1), (l + 2) with (r - 2) and so on. We do this because the character which would be put on the index l would be same as the one we put on index r. Extending this logic to all queries we need to maintain dsu. So basically all the elements of one component of dsu should have the same letter on them.
- After processing all the queries, let the number of dsu components be x, then the answer is 26
^{x}

**Complexity Analysis:** O(N * N) because we do an O(N) iteration for each query and total number of queries can be 2*N, therefore O(2*N*N). Here I have ignored the constant of union-find for simplicity.